<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Basic Concepts &#8212; jetset 1.0.a documentation</title>
    <link rel="stylesheet" href="../../_static/bootstrap-sphinx.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '1.0.a',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <script type="text/javascript" src="../../_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="../../_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="../../_static/bootstrap-3.3.6/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="../../_static/bootstrap-sphinx.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body>

  <div id="navbar" class="navbar navbar-inverse navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="../../index.html"><span><img src="../../_static/logo_small_transp.png"></span>
          JetSeT</a>
        <span class="navbar-text navbar-version pull-left"><b>1.0</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="../../index.html">JetSeT <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/user_guide.html">user guide</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../user_guide/user_guide.html#content">Content</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">Basic Concepts</a><ul>
<li><a class="reference internal" href="#work-place">work place</a></li>
<li><a class="reference internal" href="#data-format">data format</a></li>
<li><a class="reference internal" href="#loading-seds">Loading SEDs</a></li>
<li><a class="reference internal" href="#plotting-data">Plotting data</a></li>
<li><a class="reference internal" href="#grouping-data">grouping data</a></li>
<li><a class="reference internal" href="#handling-errors-and-systematics">handling errors and systematics</a></li>
<li><a class="reference internal" href="#sedshape-spectral-indices">SEDShape: Spectral indices</a></li>
<li><a class="reference internal" href="#sedshape-log-log-polynomila-fit">SEDShape: Log-Log Polynomila fit</a></li>
<li><a class="reference internal" href="#constraining-ssc-ec-model">Constraining SSC/EC model</a></li>
<li><a class="reference internal" href="#ssc-ec-fitting">SSC/EC fitting</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
            
            
              
                
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="../../_sources/tutorial/basic/basic.rst.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="../../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12 content">
      
  <div class="toctree-wrapper compound">
</div>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="o">%</span><span class="k">matplotlib</span> inline
</pre></div>
</div>
<div class="section" id="basic-concepts">
<h1>Basic Concepts<a class="headerlink" href="#basic-concepts" title="Permalink to this headline">¶</a></h1>
<div class="section" id="work-place">
<h2>work place<a class="headerlink" href="#work-place" title="Permalink to this headline">¶</a></h2>
<p>The first step is to import the package, and to set a work place:</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">BlazarSEDFit</span> <span class="kn">as</span> <span class="nn">SEDFit</span>

<span class="n">SEDFit</span><span class="o">.</span><span class="n">set_workplace</span><span class="p">(</span><span class="n">out_dir</span><span class="o">=</span><span class="s1">&#39;test-Mrk421&#39;</span><span class="p">,</span><span class="n">flag</span><span class="o">=</span><span class="s1">&#39;Mrk421&#39;</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">directory</span> <span class="n">test</span><span class="o">-</span><span class="n">Mrk421</span> <span class="n">already</span> <span class="n">existing</span>
<span class="n">removing</span> <span class="n">existing</span> <span class="nb">dir</span>
<span class="n">the</span> <span class="n">directory</span> <span class="n">test</span><span class="o">-</span><span class="n">Mrk421</span> <span class="n">has</span> <span class="n">been</span> <span class="n">created</span>
</pre></div>
</div>
<p>the latter command will set the output directory to <code class="docutils literal"><span class="pre">./test-Mrk421</span></code>
and will add a flag <code class="docutils literal"><span class="pre">Mrk421</span></code> to the output products</p>
</div>
<div class="section" id="data-format">
<h2>data format<a class="headerlink" href="#data-format" title="Permalink to this headline">¶</a></h2>
<p>The SED data can be stored in ASCII file in a quite flexible way, but
some requirements are needed:</p>
<ul class="simple">
<li>you must provide at least two columns for frequencies and fluxes</li>
<li>frequencies are in <em>Hz</em></li>
<li>fluxes are in <em>cgs</em>, …..</li>
</ul>
<p>The header of the file can contain some meta-data that are sourced when
the data are loaded. The meta-data available are :</p>
<ul class="simple">
<li>z : redhsift</li>
<li>resframe: restframe of the data <code class="docutils literal"><span class="pre">src</span></code> or <code class="docutils literal"><span class="pre">obs</span></code></li>
<li>data_scale: scale of the data <code class="docutils literal"><span class="pre">lin-lin</span></code> or <code class="docutils literal"><span class="pre">log-log</span></code></li>
<li>dataType: structure of the comumns with the SED data</li>
</ul>
<p>the meaning of these meta-data is explained in detail in <code class="xref py py-class docutils literal"><span class="pre">BlazarSEDFit.data_loader.ObsData</span></code> class
documentation. The meta-data can be included in the header with  line like:</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="c1"># metadata</span>
<span class="c1"># md z  0.0308</span>
<span class="c1"># md restframe  obs</span>
<span class="c1"># md data_scale  lin-lin</span>
<span class="c1"># md col_types x,y,dy,data_set</span>
<span class="c1"># md obj_name     J1104+3812,Mrk421</span>
<span class="c1">#</span>
</pre></div>
</div>
<p>A typical structure of SED data file, including meta-data declaration is
the following:</p>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="c1"># metadata</span>
<span class="c1"># md z  0.0308</span>
<span class="c1"># md restframe  obs</span>
<span class="c1"># md data_scale  lin-lin</span>
<span class="c1"># md col_types x,y,dy,data_set</span>
<span class="c1"># md obj_name     J1104+3812,Mrk421</span>
<span class="c1">#</span>
<span class="c1"># Frequency [Hz]  EnergyFlux [erg/cm2/s]</span>
<span class="c1">#  Xval           Yval       YvalError    data_set-flag</span>
<span class="mf">2.299540e+09</span> <span class="mf">1.340900e-14</span> <span class="mf">3.910000e-16</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">2.639697e+09</span> <span class="mf">1.793088e-14</span> <span class="mf">3.231099e-26</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">4.799040e+09</span> <span class="mf">2.313600e-14</span> <span class="mf">2.400000e-16</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">4.805039e+09</span> <span class="mf">1.773414e-14</span> <span class="mf">1.773414e-15</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">4.843552e+09</span> <span class="mf">2.776140e-14</span> <span class="mf">2.615339e-26</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">7.698460e+09</span> <span class="mf">3.696000e-14</span> <span class="mf">4.620000e-16</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">8.267346e+09</span> <span class="mf">2.836267e-14</span> <span class="mf">2.836267e-15</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">8.331867e+09</span> <span class="mf">3.989630e-14</span> <span class="mf">3.627671e-26</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">8.388659e+09</span> <span class="mf">3.163450e-14</span> <span class="mf">1.931495e-15</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">8.399994e+09</span> <span class="mf">4.000500e-14</span> <span class="mf">5.041094e-15</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">1.044892e+10</span> <span class="mf">4.626737e-14</span> <span class="mf">3.297726e-26</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">1.109778e+10</span> <span class="mf">4.617600e-14</span> <span class="mf">6.660000e-16</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
<span class="mf">1.456571e+10</span> <span class="mf">5.628417e-14</span> <span class="mf">4.453463e-26</span>    <span class="n">campaing</span><span class="o">-</span><span class="mi">2009</span>
</pre></div>
</div>
</div>
<div class="section" id="loading-seds">
<h2>Loading SEDs<a class="headerlink" href="#loading-seds" title="Permalink to this headline">¶</a></h2>
<p>The most effective way to import the SED data is to create an object
instance of <code class="xref py py-class docutils literal"><span class="pre">BlazarSEDFit.data_loader.ObsData</span></code> class
(see the documentation for the <span class="xref std std-doc">data_loader</span> module)
The package provides some test SEDs, accessible as follows:</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">SEDFit</span><span class="o">.</span><span class="n">test_SEDs</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">[</span><span class="s1">&#39;/Users/orion/anaconda2/lib/python2.7/site-packages/BlazarSEDFit/test_data/SEDs_data/SED_3C345.dat&#39;</span><span class="p">,</span>
 <span class="s1">&#39;/Users/orion/anaconda2/lib/python2.7/site-packages/BlazarSEDFit/test_data/SEDs_data/SED_MW_Mrk421.dat&#39;</span><span class="p">,</span>
 <span class="s1">&#39;/Users/orion/anaconda2/lib/python2.7/site-packages/BlazarSEDFit/test_data/SEDs_data/SED_MW_Mrk501.dat&#39;</span><span class="p">]</span>
</pre></div>
</div>
<p>to load the SED of Mrk 421, the first one in the list:</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">mySED</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">test_SEDs</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>

<span class="n">mySEDdata</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">ObsData</span><span class="p">(</span><span class="n">data_file</span><span class="o">=</span><span class="n">mySED</span><span class="p">)</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>* getting meta-data from file header
set md z  to 0.0308
set md restframe  to obs
set md data_scale  to lin-lin
set md col_types  to x,y,dy,data_set
set md obj_name  to J1104+3812,Mrk421
=============================================================================================

[]
=============================================================================================

*</strong> loading data <a href="#id1"><span class="problematic" id="id2">**</span></a>*
---&gt; loading data for file=/Users/orion/anaconda2/lib/python2.7/site-packages/BlazarSEDFit/test_data/SEDs_data/SED_MW_Mrk421.dat
---&gt; found these col ID=[0, 1, 2, 3] and names=['x', 'y', 'dy', 'data_set']:
---&gt; z=3.080000e-02
---&gt; restframe=obs
---&gt; obj_name=J1104+3812,Mrk421
---&gt; data_scale=lin-lin
nu_data x
nuFnu_data y
dnuFnu_data dy
data_set data_set
---&gt; data len=112
---&gt; Settin  UL for val 0
---&gt; Settin  UL for val 0.2
5, [  9.36164097   9.42155408   9.68115437   9.68169692   9.68516397
   9.88640386   9.91736611   9.92074233   9.92369254   9.92427898
  10.0190714   10.04523611  10.16333166  10.17390881  10.1760817
  10.1760817   10.18645992  10.34241814  10.34626611  10.36192473
  10.37657221  10.5049378   10.56820172  10.63557281  10.63560386
  10.63560386  11.36172784  14.1476145   14.15218006  14.26561016
  14.38080202  14.38216623  14.52014291  14.57266033  14.6374482
  14.6374482   14.66196206  14.67335245  14.67335245  14.71633712
  14.73737611  14.73737611  14.79796843  14.82244074  14.83619856
  15.07948442  15.14089503  15.21226353  16.92176631  17.00176529
  17.08176448  17.16176318  17.24176233  17.32176139  17.40176041
  17.48175942  17.78669947  17.86408387  17.92210689  17.94146835
  17.96990766  18.01301302  18.01885272  18.0522706   18.08831544
  18.0962372   18.12163796  18.15262433  18.17362151  18.18158322
  18.20876615  18.23437984  18.25100615  18.25859802  18.28156602
  18.30340775  18.32422976  18.32839041  18.34412395  18.36317069
  18.39833139  18.44734257  18.504513    18.55857838  18.5680578
  18.61315063  18.62373708  18.68230197  18.69856453  18.77824476
  18.81555424  18.93170083  19.14680748  19.46704604  22.58329129
  22.98330593  23.38348378  23.78346513  24.18345036  24.58345553
  24.9834565   25.38242592  25.38345486  25.58242622  25.78242697
  25.78345384  25.98242651  26.18242635  26.38242592  26.58242622
  26.78242697  26.98242651]
=============================================================================================
</pre>
<p>As you can see the all the meta-data have been properly sourced from the
SED file header. You also get information on the lenght of the data,
before and after elimination of duplicated entries, and upper limits
These meta-data are parameters needed by the</p>
<p><code class="xref py py-class docutils literal"><span class="pre">BlazarSEDFit.data_loader.ObsData</span></code> constructor.</p>
</div>
<div class="section" id="plotting-data">
<h2>Plotting data<a class="headerlink" href="#plotting-data" title="Permalink to this headline">¶</a></h2>
<p>We can now plot our SED using the <code class="xref py py-class docutils literal"><span class="pre">BlazarSEDFit.plot_sedfit.Plot</span></code> class
(see the documentation for the <span class="xref std std-doc">plot_sedfit</span> module)</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">myPlot</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">interactive</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>

<span class="n">myPlot</span><span class="o">.</span><span class="n">add_data_plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">running</span> <span class="n">PyLab</span> <span class="ow">in</span> <span class="n">interactive</span> <span class="n">mode</span>
</pre></div>
</div>
<img alt="../../_images/basic_18_1.png" src="../../_images/basic_18_1.png" />
</div>
<div class="section" id="grouping-data">
<h2>grouping data<a class="headerlink" href="#grouping-data" title="Permalink to this headline">¶</a></h2>
<p>As you can see, due to the overlapping of different instruments and to
different time snapshots, some points have multiple values. Although
this is not a problem for the fit process, you might want to rebin your
data. This can be obtained with the following command:</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">mySEDdata</span><span class="o">.</span><span class="n">group_data</span><span class="p">(</span><span class="n">bin_width</span><span class="o">=</span><span class="mf">0.2</span><span class="p">)</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>*  binning data  *</strong>
---&gt; N bins= 89
---&gt; bin_widht= 0.2
=============================================================================================
</pre>
</div>
<div class="section" id="handling-errors-and-systematics">
<h2>handling errors and systematics<a class="headerlink" href="#handling-errors-and-systematics" title="Permalink to this headline">¶</a></h2>
<p>Another important issues when dealing with fitting of data, is the
proper handling of errors. Typically one might need to add systematics
for different reasons:</p>
<ul class="simple">
<li>data are not really simultaneous, and you want to add systematics to
take this into account</li>
<li>data (typically IR up to UV), might have very small errors compared
to those at higher energies. This might bias the minimizer to
accomodate the parameters in order to fit ‘better’ the low
frequencies branch.</li>
</ul>
<p>For these reasons the package offer the possibility to add systematics</p>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">mySEDdata</span><span class="o">.</span><span class="n">add_systematics</span><span class="p">(</span><span class="mf">0.2</span><span class="p">,[</span><span class="mf">10.</span><span class="o">**</span><span class="mi">6</span><span class="p">,</span><span class="mf">10.</span><span class="o">**</span><span class="mi">29</span><span class="p">])</span>
<span class="n">myPlot</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">interactive</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
<span class="n">myPlot</span><span class="o">.</span><span class="n">add_data_plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;grouped+syst&#39;</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">running</span> <span class="n">PyLab</span> <span class="ow">in</span> <span class="n">interactive</span> <span class="n">mode</span>
</pre></div>
</div>
<img alt="../../_images/basic_22_1.png" src="../../_images/basic_22_1.png" />
<p>with this command we add 20% systematics for data between <span class="math">\(10^{6}&lt;\nu&lt;10^{29}\)</span> Hz</p>
</div>
<div class="section" id="sedshape-spectral-indices">
<h2>SEDShape: Spectral indices<a class="headerlink" href="#sedshape-spectral-indices" title="Permalink to this headline">¶</a></h2>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">SEDShape</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">SEDShape</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">)</span>
<span class="n">SEDShape</span><span class="o">.</span><span class="n">eval_indices</span><span class="p">()</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>* evaluating spectral indices for data *</strong>
---&gt; range for indexradio updated to [6.000000,10.000000]
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.016464, chisq=0.369494
res check 0.0402652596909 0.36841820873
---&gt; 1000000.0 10000000000.0 100
---&gt; name = radio            range=[6.000 ,10.000] log(Hz)  photon.val=-1.402754e+00, err=1.250721e-01

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +5.972462e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -1.935759e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=1
calls=13
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000
dof=1
chisq=0.368418, chisq/red=0.368418 null hypothesis sig=0.543868

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +5.972462e-01 | +1.250721e-01 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -1.935759e+01 | +1.212602e+00 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexradio_mm updated to [10.000000,11.000000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.074093, chisq=0.015776
res check 3.47694095737e-13 0.0139462498263
---&gt; 10000000000.0 1e+11 100
---&gt; name = radio_mm         range=[10.000,11.000] log(Hz)  photon.val=-1.290348e+00, err=3.549105e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +7.096521e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -2.047668e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=3
calls=13
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000 and the relative error between two consecutive iterates is at
  most 0.000000
dof=1
chisq=0.013946, chisq/red=0.013946 null hypothesis sig=0.905993

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +7.096521e-01 | +3.549105e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -2.047668e+01 | +3.689495e-01 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexmm_IR updated to [10.300000,13.700000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.052342, chisq=0.171012
res check 0.00565037767325 0.169889454723
---&gt; 19952623149.7 5.01187233627e+13 100
---&gt; name = mm_IR            range=[10.300,13.700] log(Hz)  photon.val=-1.109667e+00, err=5.233777e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +8.903325e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -2.236816e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=3
calls=13
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000 and the relative error between two consecutive iterates is at
  most 0.000000
dof=1
chisq=0.169889, chisq/red=0.169889 null hypothesis sig=0.680210

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +8.903325e-01 | +5.233777e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -2.236816e+01 | +5.632765e-01 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexIR_Opt updated to [12.500000,14.500000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.064843, chisq=0.032499
res check -0.0659593422521 0.0324982619
---&gt; 3.16227766017e+12 3.16227766017e+14 100
---&gt; name = IR_Opt           range=[12.500,14.500] log(Hz)  photon.val=-1.778730e+00, err=8.336742e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +2.212697e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -1.337693e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=2
calls=13
mesg=The relative error between two consecutive iterates is at most 0.000000
dof=1
chisq=0.032498, chisq/red=0.032498 null hypothesis sig=0.856938

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +2.212697e-01 | +8.336742e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -1.337693e+01 | +1.190161e+00 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexOpt_UV updated to [14.000000,16.000000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.051644, chisq=1.170535
res check -0.044459533445 1.17052755017
---&gt; 1e+14 1e+16 100
---&gt; name = Opt_UV           range=[14.000,16.000] log(Hz)  photon.val=-1.621180e+00, err=4.761716e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +3.788195e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -1.563698e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=3
calls=16
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000 and the relative error between two consecutive iterates is at
  most 0.000000
dof=5
chisq=1.170528, chisq/red=0.234106 null hypothesis sig=0.947673

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +3.788195e-01 | +4.761716e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -1.563698e+01 | +7.022031e-01 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexBBB updated to [14.800000,16.200000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.044621, chisq=0.162573
res check 0.0277778923605 0.160822681203
---&gt; 6.3095734448e+14 1.58489319246e+16 100
---&gt; name = BBB              range=[14.800,16.200] log(Hz)  photon.val=-1.273282e+00, err=1.558348e-01

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +7.267178e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -2.088315e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=1
calls=13
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000
dof=1
chisq=0.160823, chisq/red=0.160823 null hypothesis sig=0.688400

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +7.267178e-01 | +1.558348e-01 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -2.088315e+01 | +2.348493e+00 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexUV_X updated to [15.000000,17.500000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.017536, chisq=1.130575
res check -0.0186684356928 1.13057464794
---&gt; 1e+15 3.16227766017e+17 100
---&gt; name = UV_X             range=[15.000,17.500] log(Hz)  photon.val=-1.845844e+00, err=1.974304e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +1.541556e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -1.218864e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=1
calls=13
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000
dof=4
chisq=1.130575, chisq/red=0.282644 null hypothesis sig=0.889391

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +1.541556e-01 | +1.974304e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -1.218864e+01 | +3.278425e-01 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexX updated to [16.000000,19.000000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=14.789254, chisq=45.375460
res check -1.11424683221 21.9306413132
---&gt; 1e+16 1e+19 100
---&gt; name = X                range=[16.000,19.000] log(Hz)  photon.val=-2.458173e+00, err=7.557517e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | -4.581728e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -1.599716e+00 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=1
calls=16
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000
dof=9
chisq=21.930641, chisq/red=2.436738 null hypothesis sig=0.009101

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | -4.581728e-01 | +7.557517e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -1.599716e+00 | +1.345853e+00 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



---&gt; range for indexFermi updated to [22.380000,25.380000]
directory test-Mrk421/spectral-indices-best-fit/ already existing
removing existing dir
the directory test-Mrk421/spectral-indices-best-fit/ has been created
minim function calls=10, res=-0.155500, chisq=1.214222
res check -0.152092242882 1.21422039067
---&gt; 2.39883291902e+22 2.39883291902e+25 100
---&gt; name = Fermi            range=[22.380,25.380] log(Hz)  photon.val=-1.795555e+00, err=1.996363e-02

<strong>**********************************************************************************************</strong>
Fit report

Model: spectral-indices-best-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 alpha            | spectral-slope           |                  | +2.044447e-01 | [-1.000000e+01,+1.000000e+01]
 K                | flux-const               | erg cm^-2 s^-1   | -1.527441e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=1
calls=13
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000
dof=6
chisq=1.214220, chisq/red=0.202370 null hypothesis sig=0.976176

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 alpha            | +2.044447e-01 | +1.996363e-02 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 K                | -1.527441e+01 | +4.752426e-01 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>



=============================================================================================
</pre>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">myPlot</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">interactive</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>

<span class="k">for</span> <span class="n">model</span> <span class="ow">in</span> <span class="n">SEDShape</span><span class="o">.</span><span class="n">index_models</span><span class="p">:</span>
    <span class="n">myPlot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">model</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="n">model</span><span class="o">.</span><span class="n">name</span><span class="p">,</span><span class="n">line_style</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>

<span class="n">myPlot</span><span class="o">.</span><span class="n">add_data_plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;data&#39;</span><span class="p">,</span><span class="n">color</span><span class="o">=</span><span class="s1">&#39;red&#39;</span><span class="p">)</span>
<span class="n">myPlot</span><span class="o">.</span><span class="n">rescale</span><span class="p">(</span><span class="n">y_min</span><span class="o">=-</span><span class="mi">14</span><span class="p">,</span><span class="n">y_max</span><span class="o">=-</span><span class="mi">8</span><span class="p">,</span><span class="n">x_min</span><span class="o">=</span><span class="mi">8</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">running</span> <span class="n">PyLab</span> <span class="ow">in</span> <span class="n">interactive</span> <span class="n">mode</span>
</pre></div>
</div>
<img alt="../../_images/basic_26_1.png" src="../../_images/basic_26_1.png" />
</div>
<div class="section" id="sedshape-log-log-polynomila-fit">
<h2>SEDShape: Log-Log Polynomila fit<a class="headerlink" href="#sedshape-log-log-polynomila-fit" title="Permalink to this headline">¶</a></h2>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">myPlot</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="s1">&#39;SED_indices_rebinned.png&#39;</span><span class="p">)</span>


<span class="n">SEDShape</span><span class="o">.</span><span class="n">sync_fit</span><span class="p">(</span><span class="n">check_host_gal_template</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>* Log-Polynomial fitting of the synchrotron component *</strong>
---&gt; first blind fit run, log-cubic fit range: [9, 19]
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 b                | curvature                |                  | -1.000000e+00 | [-1.000000e+01,+0.000000e+00]
 c                | third-degree             |                  | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 Ep               | peak freq                | Hz               | +1.400000e+01 | [+0.000000e+00,+3.000000e+01]
 Sp               | peak flux                | erg cm^-2 s^-1   | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------
the directory test-Mrk421/sync-shape-fit/ has been created
minim function calls=10, res=2716.505338, chisq=421616.964355
minim function calls=20, res=122.820362, chisq=2160.064156
minim function calls=30, res=0.988245, chisq=14.005639
res check -0.653068653967 13.7330978665
---&gt; 1000000000.0 1e+19 100
directory test-Mrk421/sync-shape-fit/ already existing
removing existing dir
the directory test-Mrk421/sync-shape-fit/ has been created
minim function calls=10, res=1640.081276, chisq=150207.291050
minim function calls=20, res=345.553362, chisq=31425.628454
minim function calls=30, res=-86.732146, chisq=10013.760450
minim function calls=40, res=-123.758176, chisq=2245.317432
minim function calls=50, res=-1.180630, chisq=120.422889
minim function calls=60, res=-6.674315, chisq=16.672144
minim function calls=70, res=-0.965520, chisq=12.857937
minim function calls=80, res=-0.983958, chisq=12.755929
minim function calls=90, res=-0.669867, chisq=12.681773
minim function calls=100, res=-0.645531, chisq=12.476967
minim function calls=110, res=-0.848268, chisq=12.484670
minim function calls=120, res=-0.804663, chisq=12.470268
minim function calls=130, res=-0.811955, chisq=12.469534
minim function calls=140, res=-0.811759, chisq=12.467549
minim function calls=150, res=-0.820070, chisq=12.464733
minim function calls=160, res=-0.820684, chisq=12.464354
minim function calls=170, res=-0.835263, chisq=12.462286
minim function calls=180, res=-0.832090, chisq=12.460302
minim function calls=190, res=-0.832950, chisq=12.460230
minim function calls=200, res=-0.833079, chisq=12.460126
minim function calls=210, res=-0.833791, chisq=12.460093
minim function calls=220, res=-0.833810, chisq=12.459992
minim function calls=230, res=-0.833481, chisq=12.459976
minim function calls=240, res=-0.833753, chisq=12.459941
minim function calls=250, res=-0.833943, chisq=12.459888
minim function calls=260, res=-0.834217, chisq=12.459883
minim function calls=270, res=-0.834316, chisq=12.459859
minim function calls=280, res=-0.834172, chisq=12.459848
minim function calls=290, res=-0.834190, chisq=12.459841
minim function calls=300, res=-0.834227, chisq=12.459841
minim function calls=310, res=-0.834210, chisq=12.459838
res check -0.834229214569 12.4598378901
---&gt; 1000000000.0 1e+19 100

<strong>**********************************************************************************************</strong>
Fit report

Model: sync-shape-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 b                | curvature                |                  | -1.610595e-01 | [-1.000000e+01,+0.000000e+00]
 c                | third-degree             |                  | -1.120659e-02 | [-1.000000e+01,+1.000000e+01]
 Ep               | peak freq                | Hz               | +1.671935e+01 | [+0.000000e+00,+3.000000e+01]
 Sp               | peak flux                | erg cm^-2 s^-1   | -9.491676e+00 | [-3.000000e+01,+0.000000e+00]
 nuFnu_p_host     | nuFnu-scale              | erg cm^-2 s^-1   | -1.092246e+01 | [-2.000000e+01,+2.000000e+01]
 nu_scale         | nu-scale                 | Hz               | -2.424798e-01 | [-2.000000e+00,+2.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=2
calls=309
mesg=The relative error between two consecutive iterates is at most 0.000000
dof=19
chisq=12.459838, chisq/red=0.655781 null hypothesis sig=0.865041

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 b                | -1.610595e-01 | +7.727514e-03 | -1.000000e+00 | [-1.000000e+01,+0.000000e+00]
 c                | -1.120659e-02 | +1.084310e-03 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 Ep               | +1.671935e+01 | +4.368315e-02 | +1.400000e+01 | [+0.000000e+00,+3.000000e+01]
 Sp               | -9.491676e+00 | +2.799411e-02 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
 nuFnu_p_host     | -1.092246e+01 | +4.586788e-01 | -9.484348e+00 | [-1.148435e+01,-7.484348e+00]
 nu_scale         | -2.424798e-01 | +3.575422e-02 | +0.000000e+00 | [-5.000000e-01,+5.000000e-01]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>

---&gt; class:  HSP
---&gt; sync       nu_p=+1.671935e+01 (err=+4.368315e-02)  nuFnu_p=-9.491676e+00 (err=+2.799411e-02) curv.=-1.610595e-01 (err=+7.727514e-03)
</pre>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">SEDShape</span><span class="o">.</span><span class="n">IC_fit</span><span class="p">()</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>* Log-Polynomial fitting of the IC component *</strong>
---&gt; log-cubic fit range: [22, 28]
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 b                | curvature                |                  | -1.000000e+00 | [-1.000000e+01,+0.000000e+00]
 c                | third-degree             |                  | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 Ep               | peak freq                | Hz               | +2.525747e+01 | [+0.000000e+00,+3.000000e+01]
 Sp               | peak flux                | erg cm^-2 s^-1   | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------
the directory test-Mrk421/IC-shape-fit/ has been created
minim function calls=10, res=41.217378, chisq=263.542180
minim function calls=20, res=-0.672484, chisq=3.440593
res check -0.742062424495 3.43991311663
---&gt; 1e+22 1e+28 100

<strong>**********************************************************************************************</strong>
Fit report

Model: IC-shape-fit
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 b                | curvature                |                  | -2.055906e-01 | [-1.000000e+01,+0.000000e+00]
 c                | third-degree             |                  | -4.987520e-02 | [-1.000000e+01,+1.000000e+01]
 Ep               | peak freq                | Hz               | +2.525892e+01 | [+0.000000e+00,+3.000000e+01]
 Sp               | peak flux                | erg cm^-2 s^-1   | -1.012219e+01 | [-3.000000e+01,+0.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=3
calls=26
mesg=Both actual and predicted relative reductions in the sum of squares
  are at most 0.000000 and the relative error between two consecutive iterates is at
  most 0.000000
dof=12
chisq=3.439913, chisq/red=0.286659 null hypothesis sig=0.991561

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 b                | -2.055906e-01 | +2.142008e-02 | -1.000000e+00 | [-1.000000e+01,+0.000000e+00]
 c                | -4.987520e-02 | +8.368629e-03 | -1.000000e+00 | [-1.000000e+01,+1.000000e+01]
 Ep               | +2.525892e+01 | +5.759093e-02 | +2.525747e+01 | [+0.000000e+00,+3.000000e+01]
 Sp               | -1.012219e+01 | +2.552594e-02 | -1.000000e+01 | [-3.000000e+01,+0.000000e+00]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>

---&gt; IC         nu_p=+2.525892e+01 (err=+5.759093e-02)  nuFnu_p=-1.012219e+01 (err=+2.552594e-02) curv.=-2.055906e-01 (err=+2.142008e-02)
=============================================================================================
</pre>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">myPlot</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">interactive</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>


<span class="n">myPlot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">SEDShape</span><span class="o">.</span><span class="n">sync_fit</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;sync, poly-fit&#39;</span><span class="p">)</span>

<span class="n">myPlot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">SEDShape</span><span class="o">.</span><span class="n">host_gal</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;host-gal&#39;</span><span class="p">)</span>

<span class="n">myPlot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">SEDShape</span><span class="o">.</span><span class="n">sync_fit_model</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;sync+host, poly-fit&#39;</span><span class="p">)</span>
<span class="n">myPlot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">SEDShape</span><span class="o">.</span><span class="n">IC_fit_model</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;IC, poly-fit&#39;</span><span class="p">)</span>
<span class="n">myPlot</span><span class="o">.</span><span class="n">add_data_plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
<span class="n">myPlot</span><span class="o">.</span><span class="n">rescale</span><span class="p">(</span><span class="n">y_min</span><span class="o">=-</span><span class="mi">14</span><span class="p">,</span><span class="n">y_max</span><span class="o">=-</span><span class="mi">8</span><span class="p">,</span><span class="n">x_min</span><span class="o">=</span><span class="mi">8</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span>running PyLab in interactive mode
&lt;bound method SEDShape.sync_fit of &lt;BlazarSEDFit.sed_shaper.SEDShape object at 0x1a1b5e0610&gt;&gt; !!! Error has no SED instance or something wrong in get_model_points()
</pre></div>
</div>
<img alt="../../_images/basic_30_1.png" src="../../_images/basic_30_1.png" />
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">SEDShape</span><span class="o">.</span><span class="n">show_values</span><span class="p">()</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>* SEDShape values *</strong>
---&gt; spectral inidces values
---&gt; name = radio            range=[6.000 ,10.000] log(Hz)  photon.val=-1.402754e+00, err=1.250721e-01
---&gt; name = radio_mm         range=[10.000,11.000] log(Hz)  photon.val=-1.290348e+00, err=3.549105e-02
---&gt; name = mm_IR            range=[10.300,13.700] log(Hz)  photon.val=-1.109667e+00, err=5.233777e-02
---&gt; name = IR_Opt           range=[12.500,14.500] log(Hz)  photon.val=-1.778730e+00, err=8.336742e-02
---&gt; name = Opt_UV           range=[14.000,16.000] log(Hz)  photon.val=-1.621180e+00, err=4.761716e-02
---&gt; name = BBB              range=[14.800,16.200] log(Hz)  photon.val=-1.273282e+00, err=1.558348e-01
---&gt; name = UV_X             range=[15.000,17.500] log(Hz)  photon.val=-1.845844e+00, err=1.974304e-02
---&gt; name = X                range=[16.000,19.000] log(Hz)  photon.val=-2.458173e+00, err=7.557517e-02
---&gt; name = Fermi            range=[22.380,25.380] log(Hz)  photon.val=-1.795555e+00, err=1.996363e-02


---&gt; S/IC peak values
---&gt; sync       nu_p=+1.671935e+01 (err=+4.368315e-02)  nuFnu_p=-9.491676e+00 (err=+2.799411e-02) curv.=-1.610595e-01 (err=+7.727514e-03)

---&gt; IC         nu_p=+2.525892e+01 (err=+5.759093e-02)  nuFnu_p=-1.012219e+01 (err=+2.552594e-02) curv.=-2.055906e-01 (err=+2.142008e-02)


=============================================================================================
</pre>
</div>
<div class="section" id="constraining-ssc-ec-model">
<h2>Constraining SSC/EC model<a class="headerlink" href="#constraining-ssc-ec-model" title="Permalink to this headline">¶</a></h2>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">SED_obspar</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">ObsConstrain</span><span class="p">(</span><span class="n">beaming</span><span class="o">=</span><span class="mi">25</span><span class="p">,</span><span class="n">B_range</span><span class="o">=</span><span class="p">[</span><span class="mf">0.01</span><span class="p">,</span><span class="mf">0.1</span><span class="p">],</span><span class="n">distr_e</span><span class="o">=</span><span class="s1">&#39;lppl&#39;</span><span class="p">,</span><span class="n">t_var_sec</span><span class="o">=</span><span class="mi">3</span><span class="o">*</span><span class="mi">86400</span><span class="p">,</span><span class="n">nu_cut_IR</span><span class="o">=</span><span class="mf">9.0E12</span><span class="p">,</span><span class="n">SEDShape</span><span class="o">=</span><span class="n">SEDShape</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">jet_model</span><span class="o">=</span><span class="n">SED_obspar</span><span class="o">.</span><span class="n">constrain_SSC_model</span><span class="p">()</span>
</pre></div>
</div>
<pre class="literal-block">
=============================================================================================

<strong>*  constrains parameters from observable *</strong>

the directory test-Mrk421/obs_constrain_lppl/ has been created
the directory test-Mrk421/lppl_BalzarSED_prod/ has been created
directory test-Mrk421/obs_constrain_lppl/ already existing
removing existing dir
the directory test-Mrk421/obs_constrain_lppl/ has been created
-----------------------------------------------------------------------------------------
model parameters for jet model:

electron distribution type = lppl
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 gmax             | high-energy-cut-off      | Lorentz-factor   | +1.000000e+08 | [+1.000000e+00,No           ]
 gmin             | low-energy-cut-off       | Lorentz-factor   | +2.000000e+00 | [+1.000000e+00,No           ]
 N                | electron_density         | cm^-3            | +1.000000e+02 | [+0.000000e+00,No           ]
 s                | LE_spectral_slope        |                  | +2.000000e+00 | [-1.000000e+01,+1.000000e+01]
 r                | spectral_curvature       |                  | +4.000000e-01 | [-1.000000e+01,+1.000000e+01]
 gamma0_log_parab | turn-over-energy         | Lorentz-factor   | +1.000000e+04 | [+1.000000e+00,No           ]
 z_cosm           | redshift                 |                  | +1.000000e-01 | [+0.000000e+00,No           ]
 B                | magnetic_field           | G                | +1.000000e-01 | [+0.000000e+00,No           ]
 R                | region_size              | cm               | +3.000000e+15 | [+0.000000e+00,No           ]
 beam_obj         | beaming                  |                  | +1.000000e+01 | [+1.000000e+00,No           ]
--------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
---&gt; <strong>*  emitting region parameters  *</strong>
---&gt; name = beam_obj          type = beaming                   units =                   val = +2.500000e+01  phys-bounds = [+1.000000e+00,No           ]
---&gt; setting par type redshift, corresponding to par z_cosm
---&gt;  name = z_cosm            type = redshift                  units =                   val = +3.080000e-02  phys-bounds = [+0.000000e+00,No           ]

---&gt; setting par type magnetic_field, corresponding to par B
---&gt;  name = B                 type = magnetic_field            units = G                 val = +5.500000e-02  phys-bounds = [+0.000000e+00,No           ]

---&gt; setting par type region_size, corresponding to par R
---&gt;  name = R                 type = region_size               units = cm                val = +1.884609e+17  phys-bounds = [+0.000000e+00,No           ]


---&gt; <strong>* electron distribution parameters *</strong>
---&gt; distribution type:  lppl
---&gt; r elec. spec. curvature =8.052977e-01
---&gt; setting par type curvature, corresponding to par r
---&gt;  name = r                 type = spectral_curvature        units =                   val = +8.052977e-01  phys-bounds = [-1.000000e+01,+1.000000e+01]

---&gt; s_radio_mm -0.290347851672 1.58069570334
---&gt; s_X 3.91634563802
---&gt; s_Fermi 1.67288843433
---&gt; s_UV_X 2.69168888009
---&gt; s_Opt_UV -0.621180474873 2.24236094975
---&gt; s from synch log-log fit -1.0
---&gt; s from (s_Fermi + s_UV)/2
---&gt; power-law index s, class obj=HSP s chosen is 2.182289
---&gt; setting par type LE_spectral_slope, corresponding to par s
---&gt;  name = s                 type = LE_spectral_slope         units =                   val = +2.182289e+00  phys-bounds = [-1.000000e+01,+1.000000e+01]

---&gt; gamma_3p_Sync= 1.030414e+05, assuming B=5.500000e-02
---&gt; gamma_max=1.315786e+06 from nu_max_Sync= 8.544779e+18, using B=5.500000e-02
---&gt; setting par type high-energy-cut-off, corresponding to par gmax
---&gt;  name = gmax              type = high-energy-cut-off       units = Lorentz-factor    val = +1.315786e+06  phys-bounds = [+1.000000e+00,No           ]

---&gt; setting par type low-energy-cut-off, corresponding to par gmin
---&gt;  name = gmin              type = low-energy-cut-off        units = Lorentz-factor    val = +1.350381e+03  phys-bounds = [+1.000000e+00,No           ]

---&gt; setting par type turn-over energy, corresponding to par gamma0_log_parab
---&gt; using gamma_3p_Sync= 103041.449202
---&gt;  name = gamma0_log_parab  type = turn-over-energy          units = Lorentz-factor    val = +3.201138e+04  phys-bounds = [+1.000000e+00,No           ]

nu_p_seed_blob 2.16066944164e+15
COMP FACTOR 1.80188052755 24815.4593326
---&gt; gamma_3p_SSCc= %e 161721.968548
---&gt; setting par type turn-over energy, corresponding to par gamma0_log_parab
---&gt; using gamma_3p_SSC= 161721.968548
---&gt;  name = gamma0_log_parab  type = turn-over-energy          units = Lorentz-factor    val = +5.024138e+04  phys-bounds = [+1.000000e+00,No           ]


('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
---&gt; setting par type electron_density, corresponding to par N
---&gt; B from nu_p_S=2.232794e-02
---&gt; get B from best matching of nu_p_IC
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
---&gt; B=4.198840e-01, out of boundaries 1.000000e-02 1.000000e-01, rejected
     Best B not found, (temporary set to 1.000000e-01)
---&gt; setting par type magnetic_field, corresponding to par B
---&gt;  name = B                 type = magnetic_field            units = G                 val = +1.000000e-01  phys-bounds = [+0.000000e+00,No           ]

---&gt; constrain failed, B set to:  name = B                 type = magnetic_field            units = G                 val = +1.000000e-01  phys-bounds = [+0.000000e+00,No           ]


---&gt; update pars for new B
---&gt; setting par type low-energy-cut-off, corresponding to par gmin
---&gt;  name = gmin              type = low-energy-cut-off        units = Lorentz-factor    val = +1.001469e+03  phys-bounds = [+1.000000e+00,No           ]

---&gt; setting par type low-energy-cut-off, corresponding to par gamma0_log_parab
---&gt; using gamma_3p_Sync= 76417.5839683
---&gt;  name = gamma0_log_parab  type = turn-over-energy          units = Lorentz-factor    val = +2.374028e+04  phys-bounds = [+1.000000e+00,No           ]

---&gt; gamma_max=9.758134e+05 from nu_max_Sync= 8.544779e+18, using B=1.000000e-01
---&gt; setting par type high-energy-cut-off, corresponding to par gmax
---&gt;  name = gmax              type = high-energy-cut-off       units = Lorentz-factor    val = +9.758134e+05  phys-bounds = [+1.000000e+00,No           ]

('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
---&gt; setting par type electron_density, corresponding to par N
---&gt; get R from Compoton Dominance (CD)
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
     Best R=1.596382e+16
---&gt; setting par type region_size, corresponding to par R
---&gt;  name = R                 type = region_size               units = cm                val = +1.596382e+16  phys-bounds = [+0.000000e+00,No           ]

('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
---&gt; setting par type electron_density, corresponding to par N
---&gt; t_var (days) 0.254118754751

show pars
-----------------------------------------------------------------------------------------
model parameters for jet model:

electron distribution type = lppl
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 gmax             | high-energy-cut-off      | Lorentz-factor   | +9.758134e+05 | [+1.000000e+00,No           ]
 gmin             | low-energy-cut-off       | Lorentz-factor   | +1.001469e+03 | [+1.000000e+00,No           ]
 N                | electron_density         | cm^-3            | +8.354168e-01 | [+0.000000e+00,No           ]
 s                | LE_spectral_slope        |                  | +2.182289e+00 | [-1.000000e+01,+1.000000e+01]
 r                | spectral_curvature       |                  | +8.052977e-01 | [-1.000000e+01,+1.000000e+01]
 gamma0_log_parab | turn-over-energy         | Lorentz-factor   | +2.374028e+04 | [+1.000000e+00,No           ]
 z_cosm           | redshift                 |                  | +3.080000e-02 | [+0.000000e+00,No           ]
 B                | magnetic_field           | G                | +1.000000e-01 | [+0.000000e+00,No           ]
 R                | region_size              | cm               | +1.596382e+16 | [+0.000000e+00,No           ]
 beam_obj         | beaming                  |                  | +2.500000e+01 | [+1.000000e+00,No           ]
--------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
eval_model
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
directory test-Mrk421/lppl_BalzarSED_prod/ already existing
removing existing dir
the directory test-Mrk421/lppl_BalzarSED_prod/ has been created

=============================================================================================
</pre>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">constr_Plot</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">interactive</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>
<span class="n">constr_Plot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">jet_model</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;obs-constr-lppl&#39;</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span><span class="n">update</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>
<span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">jet_model</span><span class="o">.</span><span class="n">spectral_components</span><span class="p">:</span>
    <span class="n">constr_Plot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">c</span><span class="o">.</span><span class="n">SED</span><span class="p">,</span><span class="n">line_style</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">)</span>
<span class="n">constr_Plot</span><span class="o">.</span><span class="n">add_data_plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
<span class="n">constr_Plot</span><span class="o">.</span><span class="n">rescale</span><span class="p">(</span><span class="n">y_min</span><span class="o">=-</span><span class="mi">14</span><span class="p">,</span><span class="n">y_max</span><span class="o">=-</span><span class="mi">8</span><span class="p">,</span><span class="n">x_min</span><span class="o">=</span><span class="mi">8</span><span class="p">)</span>
<span class="n">constr_Plot</span><span class="o">.</span><span class="n">add_residual_plot</span><span class="p">(</span><span class="n">jet_model</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">&lt;</span><span class="n">BlazarSEDFit</span><span class="o">.</span><span class="n">jet_model</span><span class="o">.</span><span class="n">Jet</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1a1bef9050</span><span class="o">&gt;</span> <span class="n">has</span> <span class="n">no</span> <span class="n">residuals</span>
</pre></div>
</div>
<img alt="../../_images/basic_35_1.png" src="../../_images/basic_35_1.png" />
</div>
<div class="section" id="ssc-ec-fitting">
<h2>SSC/EC fitting<a class="headerlink" href="#ssc-ec-fitting" title="Permalink to this headline">¶</a></h2>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">SEDModel</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">FitModel</span><span class="p">(</span> <span class="n">jet</span><span class="o">=</span><span class="n">jet_model</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="s1">&#39;SSC-best-fit&#39;</span><span class="p">,</span>  <span class="n">template</span><span class="o">=</span><span class="n">SEDShape</span><span class="o">.</span><span class="n">host_gal</span><span class="p">)</span>

<span class="n">SEDModel</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;z_cosm&#39;</span><span class="p">,</span><span class="s1">&#39;frozen&#39;</span><span class="p">)</span>

<span class="n">SEDModel</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;beam_obj&#39;</span><span class="p">,</span><span class="s1">&#39;frozen&#39;</span><span class="p">)</span>

<span class="n">SEDModel</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;nuFnu_p_host&#39;</span><span class="p">,</span><span class="s1">&#39;frozen&#39;</span><span class="p">)</span>

<span class="c1">#SEDModel.set(&#39;L_host&#39;,fit_range=[-10.5,-9.5])</span>

<span class="n">SEDModel</span><span class="o">.</span><span class="n">show_pars</span><span class="p">()</span>

<span class="n">best_fit</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">fit_SED</span><span class="p">(</span><span class="n">SEDModel</span><span class="p">,</span><span class="n">mySEDdata</span><span class="p">,</span><span class="mf">10.0</span><span class="o">**</span><span class="mi">11</span> <span class="p">,</span><span class="mi">10</span><span class="o">**</span><span class="mf">28.0</span><span class="p">,</span><span class="n">fitname</span><span class="o">=</span><span class="s1">&#39;SSC-best-fit-lppl&#39;</span><span class="p">)</span>
</pre></div>
</div>
<pre class="literal-block">
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 gmax             | high-energy-cut-off      | Lorentz-factor   | +9.758134e+05 | [+1.000000e+00,No           ]
 gmin             | low-energy-cut-off       | Lorentz-factor   | +1.001469e+03 | [+1.000000e+00,No           ]
 N                | electron_density         | cm^-3            | +8.354168e-01 | [+0.000000e+00,No           ]
 s                | LE_spectral_slope        |                  | +2.182289e+00 | [-1.000000e+01,+1.000000e+01]
 r                | spectral_curvature       |                  | +8.052977e-01 | [-1.000000e+01,+1.000000e+01]
 gamma0_log_parab | turn-over-energy         | Lorentz-factor   | +2.374028e+04 | [+1.000000e+00,No           ]
 z_cosm           | redshift                 |                  | +3.080000e-02 | [+0.000000e+00,No           ]
 B                | magnetic_field           | G                | +1.000000e-01 | [+0.000000e+00,No           ]
 R                | region_size              | cm               | +1.596382e+16 | [+0.000000e+00,No           ]
 beam_obj         | beaming                  |                  | +2.500000e+01 | [+1.000000e+00,No           ]
 nuFnu_p_host     | nuFnu-scale              | erg cm^-2 s^-1   | -1.092246e+01 | [-2.000000e+01,+2.000000e+01]
 nu_scale         | nu-scale                 | Hz               | -2.424798e-01 | [-2.000000e+00,+2.000000e+00]
--------------------------------------------------------------------------------------------------------------
the directory test-Mrk421/SSC-best-fit-lppl/ has been created
directory test-Mrk421/SSC-best-fit-lppl/ already existing
removing existing dir
the directory test-Mrk421/SSC-best-fit-lppl/ has been created
filtering data in fit range = [1.000000e+11,1.000000e+28]
data length 37
=============================================================================================

<strong>* start fit process *</strong>
initial pars:
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 gmax             | high-energy-cut-off      | Lorentz-factor   | +9.758134e+05 | [+1.000000e+00,No           ]
 gmin             | low-energy-cut-off       | Lorentz-factor   | +1.001469e+03 | [+1.000000e+00,No           ]
 N                | electron_density         | cm^-3            | +8.354168e-01 | [+0.000000e+00,No           ]
 s                | LE_spectral_slope        |                  | +2.182289e+00 | [-1.000000e+01,+1.000000e+01]
 r                | spectral_curvature       |                  | +8.052977e-01 | [-1.000000e+01,+1.000000e+01]
 gamma0_log_parab | turn-over-energy         | Lorentz-factor   | +2.374028e+04 | [+1.000000e+00,No           ]
 z_cosm           | redshift                 |                  | +3.080000e-02 | [+0.000000e+00,No           ]
 B                | magnetic_field           | G                | +1.000000e-01 | [+0.000000e+00,No           ]
 R                | region_size              | cm               | +1.596382e+16 | [+0.000000e+00,No           ]
 beam_obj         | beaming                  |                  | +2.500000e+01 | [+1.000000e+00,No           ]
 nuFnu_p_host     | nuFnu-scale              | erg cm^-2 s^-1   | -1.092246e+01 | [-2.000000e+01,+2.000000e+01]
 nu_scale         | nu-scale                 | Hz               | -2.424798e-01 | [-2.000000e+00,+2.000000e+00]
--------------------------------------------------------------------------------------------------------------
minim function calls=10, res=6.254838, chisq=51.023390
minim function calls=20, res=20.427053, chisq=42.442316
minim function calls=30, res=13.536695, chisq=27.941047
minim function calls=40, res=6.346978, chisq=25.133479
minim function calls=50, res=6.515088, chisq=24.474775
minim function calls=60, res=6.432289, chisq=23.939057
minim function calls=70, res=6.463441, chisq=23.917825
minim function calls=80, res=6.469671, chisq=23.921373
res check 6.46344851638 23.9178376853

<strong>**********************************************************************************************</strong>
Fit report

Model: SSC-best-fit-lppl
--------------------------------------------------------------------------------------------------------------
model parameters:
 Name             | Type                     | Units            | value         | phys. boundaries
--------------------------------------------------------------------------------------------------------------
 gmax             | high-energy-cut-off      | Lorentz-factor   | +1.916934e+10 | [+1.000000e+00,No           ]
 gmin             | low-energy-cut-off       | Lorentz-factor   | +8.376770e+02 | [+1.000000e+00,No           ]
 N                | electron_density         | cm^-3            | +7.597617e-01 | [+0.000000e+00,No           ]
 s                | LE_spectral_slope        |                  | +2.199129e+00 | [-1.000000e+01,+1.000000e+01]
 r                | spectral_curvature       |                  | +1.133504e+00 | [-1.000000e+01,+1.000000e+01]
 gamma0_log_parab | turn-over-energy         | Lorentz-factor   | +5.274453e+04 | [+1.000000e+00,No           ]
 z_cosm           | redshift                 |                  | +3.080000e-02 | [+0.000000e+00,No           ]
 B                | magnetic_field           | G                | +6.257517e-02 | [+0.000000e+00,No           ]
 R                | region_size              | cm               | +2.110445e+16 | [+0.000000e+00,No           ]
 beam_obj         | beaming                  |                  | +2.500000e+01 | [+1.000000e+00,No           ]
 nuFnu_p_host     | nuFnu-scale              | erg cm^-2 s^-1   | -1.092246e+01 | [-2.000000e+01,+2.000000e+01]
 nu_scale         | nu-scale                 | Hz               | -2.254570e-01 | [-2.000000e+00,+2.000000e+00]
--------------------------------------------------------------------------------------------------------------

converged=2
calls=86
mesg=The relative error between two consecutive iterates is at most 0.000000
dof=28
chisq=23.917572, chisq/red=0.854199 null hypothesis sig=0.685879

best fit pars
---------------------------------------------------------------------------------------------------
best-fit parameters:
  Name            | best-fit value| best-fit err  | start value   | fit boundaries
---------------------------------------------------------------------------------------------------
 gmax             | +1.916934e+10 | +1.838393e+16 | +9.758134e+05 | [+1.000000e+00,No           ]
 gmin             | +8.376770e+02 | +1.747311e+04 | +1.001469e+03 | [+1.000000e+00,No           ]
 N                | +7.597617e-01 | +1.851366e+01 | +8.354168e-01 | [+0.000000e+00,No           ]
 s                | +2.199129e+00 | +1.147699e-01 | +2.182289e+00 | [-1.000000e+01,+1.000000e+01]
 r                | +1.133504e+00 | +1.882519e-01 | +8.052977e-01 | [-1.000000e+01,+1.000000e+01]
 gamma0_log_parab | +5.274453e+04 | +2.338585e+04 | +2.374028e+04 | [+1.000000e+00,No           ]
 z_cosm           | Frozen        | Frozen        | +3.080000e-02 | [+0.000000e+00,No           ]
 B                | +6.257517e-02 | +2.401991e-02 | +1.000000e-01 | [+0.000000e+00,No           ]
 R                | +2.110445e+16 | +8.287825e+15 | +1.596382e+16 | [+0.000000e+00,No           ]
 beam_obj         | Frozen        | Frozen        | +2.500000e+01 | [+1.000000e+00,No           ]
 nuFnu_p_host     | Frozen        | Frozen        | -1.092246e+01 | [-1.148435e+01,-7.484348e+00]
 nu_scale         | -2.254570e-01 | +2.615069e-02 | -2.424798e-01 | [-5.000000e-01,+5.000000e-01]
---------------------------------------------------------------------------------------------------
<strong>**********************************************************************************************</strong>

---&gt; 1e+11 1e+28 100
('fill name', 'Sum')
('fill name', 'Sync')
('fill name', 'SSC')
=============================================================================================
</pre>
<div class="highlight-ipython2"><div class="highlight"><pre><span></span><span class="n">fit_Plot</span><span class="o">=</span><span class="n">SEDFit</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">interactive</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
<span class="n">fit_Plot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">SEDModel</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="s1">&#39;SSC-best-fit&#39;</span><span class="p">)</span>
<span class="n">fit_Plot</span><span class="o">.</span><span class="n">autoscale</span><span class="p">()</span>
<span class="n">fit_Plot</span><span class="o">.</span><span class="n">rescale</span><span class="p">(</span><span class="n">y_min</span><span class="o">=-</span><span class="mi">14</span><span class="p">,</span><span class="n">y_max</span><span class="o">=-</span><span class="mi">8</span><span class="p">,</span><span class="n">x_min</span><span class="o">=</span><span class="mf">9.0</span><span class="p">,</span><span class="n">x_max</span><span class="o">=</span><span class="mi">30</span><span class="p">)</span>
<span class="n">fit_Plot</span><span class="o">.</span><span class="n">x_min_res</span><span class="o">=</span><span class="mf">5.5</span>
<span class="n">fit_Plot</span><span class="o">.</span><span class="n">x_max_res</span><span class="o">=</span><span class="mi">30</span>
<span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">SEDModel</span><span class="o">.</span><span class="n">components</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">spectral_components</span><span class="p">:</span>
    <span class="n">fit_Plot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">c</span><span class="o">.</span><span class="n">SED</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span><span class="n">line_style</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">)</span>

<span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">SEDModel</span><span class="o">.</span><span class="n">components</span><span class="p">:</span>
    <span class="n">fit_Plot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="n">c</span><span class="o">.</span><span class="n">SED</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span><span class="n">line_style</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">)</span>

<span class="n">fit_Plot</span><span class="o">.</span><span class="n">add_data_plot</span><span class="p">(</span><span class="n">mySEDdata</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span><span class="n">color</span><span class="o">=</span><span class="s1">&#39;b&#39;</span><span class="p">)</span>


<span class="n">fit_Plot</span><span class="o">.</span><span class="n">add_residual_plot</span><span class="p">(</span><span class="n">SEDModel</span><span class="p">)</span>
</pre></div>
</div>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">running</span> <span class="n">PyLab</span> <span class="ow">in</span> <span class="n">interactive</span> <span class="n">mode</span>
</pre></div>
</div>
<img alt="../../_images/basic_38_1.png" src="../../_images/basic_38_1.png" />
</div>
</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2018, andrea tramacere.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.6.6.<br/>
    </p>
  </div>
</footer>
  </body>
</html>